"""Configuration settings for SciCraft."""

import os
from ConfigParser import ConfigParser

# we use -ng to make sure it doesn't affect settings from old (pre
# 0.50) scicrafts. For windows it doesn't matter, as older scicraft
# installations didn't use %APPDATA%.
if os.name == "posix":
    _settings_path = os.path.join(os.environ["HOME"], ".scicraft-ng")
elif os.name == "nt":
    _settings_path = os.path.join(os.environ["APPDATA"], "SciCraft")

if not os.path.exists(_settings_path):
    os.mkdir(_settings_path)

_conf_file = os.path.join(_settings_path, "scicraft.conf")

def write_config():
    parser = ConfigParser()
    parser.add_section("paths")
    parser.add_section("logger")
    parser.add_section("R settings")
    if os.name == "posix":
        parser.set("paths", "user_workflow_paths", ":".join(user_workflow_paths))
    elif os.name == "nt":
        parser.set("paths", "user_workflow_paths", ";".join(user_workflow_paths))
    parser.set("R settings", "r_lib_download_site", r_CRAN_mirror)
    parser.set("logger", "level", logg_level)
    parser.write(open(_conf_file, "w"))
def read_config():
    global user_workflow_paths
    global r_CRAN_mirror
    global logg_level
    parser = ConfigParser()
    parser.read(_conf_file)
    if parser.has_option("paths", "user_workflow_paths"):
        _path_string = parser.get("paths", "user_workflow_paths")
        if os.name == "posix":
            paths = _path_string.split(":")
        elif os.name == "nt":
            paths = _path_string.split(";")
        user_workflow_paths = filter(None, paths)
    if parser.has_option("R settings", "r_lib_download_site"):
        r_CRAN_mirror = parser.get("R settings", "r_lib_download_site")
    if parser.has_option("logger", "level"):
        logg_level = parser.get("logger", "level")

# default configuration settings, add new settings here when
# appropriate:
user_workflow_paths = []
#The old path had problems findig packages(http://cran.dk.r-project.org/)
#Testing the CRAN master path(http://cran.r-project.org)
r_CRAN_mirror = 'http://cran.r-project.org'
logg_level = "notice"

# read existing configuration if it exists
if os.path.exists(_conf_file):
    read_config()

write_config()
