from system import workflow, dataset, plots, logger


class GlWorkflow(workflow.Workflow):
    name = 'OpenGL workflow'
    ident = 'glworkflow'
    description = 'OpenGL workflow' 
    def __init__(self, app):
        workflow.Workflow.__init__(self, app)
               
        # load
        load = workflow.Stage('plots', 'Generate plots')
        load.add_function(MeshPlotFunction())
        self.add_stage(load)   

class MeshPlotFunction(workflow.Function):
    def __init__(self):
        workflow.Function.__init__(self, 'meshplot', 'Mesh plot')
    
    def run(self, data1):
        try:
            from gtk.gtkgl.apputils import *
            from meshplot import MeshPlotBox
            return [MeshPlotBox(data1)]
        except ImportError:
            logger.log("error","Unable to use 3D Plotting, OpenGL library not available.")
     

